searchNodes=[{"doc":"Boruta is the core of an OAuth/OpenID Connect provider implementing authorization business rules. Documentation","ref":"Boruta.html","title":"Boruta","type":"module"},{"doc":"Utilities to access Boruta configuration ad set defaults. Boruta configuration can be set as following in config.exs overriding following default configuration config :boruta , Boruta.Oauth , repo : MyApp.Repo , # mandatory cache_backend : Boruta.Cache , contexts : [ access_tokens : Boruta.Ecto.AccessTokens , clients : Boruta.Ecto.Clients , codes : Boruta.Ecto.Codes , resource_owners : MyApp.ResourceOwners , # mandatory for user flows scopes : Boruta.Ecto.Scopes ] , max_ttl : [ authorization_code : 60 , access_token : 60 * 60 * 24 , id_token : 60 * 60 * 24 , refresh_token : 60 * 60 * 24 * 30 ] , token_generator : Boruta.TokenGenerator , issuer : &quot;boruta&quot;","ref":"Boruta.Config.html","title":"Boruta.Config","type":"module"},{"doc":"Administration of Boruta resources.","ref":"Boruta.Ecto.Admin.html","title":"Boruta.Ecto.Admin","type":"module"},{"doc":"See Boruta.Ecto.Admin.Clients.create_client/1 .","ref":"Boruta.Ecto.Admin.html#create_client/1","title":"Boruta.Ecto.Admin.create_client/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.create_scope/1 .","ref":"Boruta.Ecto.Admin.html#create_scope/1","title":"Boruta.Ecto.Admin.create_scope/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.delete_client/1 .","ref":"Boruta.Ecto.Admin.html#delete_client/1","title":"Boruta.Ecto.Admin.delete_client/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Tokens.delete_inactive_tokens/0 .","ref":"Boruta.Ecto.Admin.html#delete_inactive_tokens/0","title":"Boruta.Ecto.Admin.delete_inactive_tokens/0","type":"function"},{"doc":"See Boruta.Ecto.Admin.Tokens.delete_inactive_tokens/1 .","ref":"Boruta.Ecto.Admin.html#delete_inactive_tokens/1","title":"Boruta.Ecto.Admin.delete_inactive_tokens/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.delete_scope/1 .","ref":"Boruta.Ecto.Admin.html#delete_scope/1","title":"Boruta.Ecto.Admin.delete_scope/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.get_client!/1 .","ref":"Boruta.Ecto.Admin.html#get_client!/1","title":"Boruta.Ecto.Admin.get_client!/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.get_scope!/1 .","ref":"Boruta.Ecto.Admin.html#get_scope!/1","title":"Boruta.Ecto.Admin.get_scope!/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.get_scopes_by_ids/1 .","ref":"Boruta.Ecto.Admin.html#get_scopes_by_ids/1","title":"Boruta.Ecto.Admin.get_scopes_by_ids/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.get_scopes_by_names/1 .","ref":"Boruta.Ecto.Admin.html#get_scopes_by_names/1","title":"Boruta.Ecto.Admin.get_scopes_by_names/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Tokens.list_active_tokens/0 .","ref":"Boruta.Ecto.Admin.html#list_active_tokens/0","title":"Boruta.Ecto.Admin.list_active_tokens/0","type":"function"},{"doc":"See Boruta.Ecto.Admin.Tokens.list_active_tokens/1 .","ref":"Boruta.Ecto.Admin.html#list_active_tokens/1","title":"Boruta.Ecto.Admin.list_active_tokens/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.list_clients/0 .","ref":"Boruta.Ecto.Admin.html#list_clients/0","title":"Boruta.Ecto.Admin.list_clients/0","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.list_scopes/0 .","ref":"Boruta.Ecto.Admin.html#list_scopes/0","title":"Boruta.Ecto.Admin.list_scopes/0","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.regenerate_client_secret/1 .","ref":"Boruta.Ecto.Admin.html#regenerate_client_secret/1","title":"Boruta.Ecto.Admin.regenerate_client_secret/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.regenerate_client_secret/2 .","ref":"Boruta.Ecto.Admin.html#regenerate_client_secret/2","title":"Boruta.Ecto.Admin.regenerate_client_secret/2","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.update_client/2 .","ref":"Boruta.Ecto.Admin.html#update_client/2","title":"Boruta.Ecto.Admin.update_client/2","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.update_scope/2 .","ref":"Boruta.Ecto.Admin.html#update_scope/2","title":"Boruta.Ecto.Admin.update_scope/2","type":"function"},{"doc":"OAuth requests entrypoint, provides authorization artifacts to clients as stated in RFC . Note : this module follows inverted heaxagonal architecture, its functions will invoke callbacks of the given module argument and return its result. The definition of those callbacks are provided by either Boruta.Oauth.Application or Boruta.Oauth.AuthorizeApplication , Boruta.Oauth.TokenApplication , Boruta.Oauth.IntrospectApplication , and Boruta.Oauth.RevokeApplication ,","ref":"Boruta.Oauth.html","title":"Boruta.Oauth","type":"module"},{"doc":"Process an authorize request as stated in RFC 6749 - The OAuth 2.0 Authorization Framework and OpenID Connect Core 1.0 incorporating errata set 1 . Triggers authorize_success in case of success and authorize_error in case of failure from the given module . Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#authorize/3","title":"Boruta.Oauth.authorize/3","type":"function"},{"doc":"Process a introspect request as stated in RFC 7662 - OAuth 2.0 Token Introspection . Triggers introspect_success in case of success and introspect_error in case of failure from the given module . Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#introspect/2","title":"Boruta.Oauth.introspect/2","type":"function"},{"doc":"Check success of an authorize request as stated in RFC 6749 - The OAuth 2.0 Authorization Framework and OpenID Connect Core 1.0 incorporating errata set 1 . Triggers preauthorize_success in case of success and preauthorize_error in case of failure from the given module . Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#preauthorize/3","title":"Boruta.Oauth.preauthorize/3","type":"function"},{"doc":"Process a revoke request as stated in RFC 7009 - OAuth 2.0 Token Revocation . Triggers revoke_success in case of success and revoke_error in case of failure from the given module . Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#revoke/2","title":"Boruta.Oauth.revoke/2","type":"function"},{"doc":"Process an token request as stated in RFC 6749 - The OAuth 2.0 Authorization Framework . Triggers token_success in case of success and token_error in case of failure from the given module . Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#token/2","title":"Boruta.Oauth.token/2","type":"function"},{"doc":"Implement this behaviour in the application layer of your OAuth / OpenID Connect provider. This behaviour gives all callbacks triggered invoking Boruta.Oauth module functions. Note : This behaviour is splitted into Boruta.Oauth.AuthorizeApplication , Boruta.Oauth.TokenApplication , Boruta.Oauth.IntrospectApplication , and Boruta.Oauth.RevokeApplication providing utilities to implement the different OAuth / OpenID Connect endpoints independently.","ref":"Boruta.Oauth.Application.html","title":"Boruta.Oauth.Application","type":"behaviour"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.authorize/3","ref":"Boruta.Oauth.Application.html#c:authorize_error/2","title":"Boruta.Oauth.Application.authorize_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.authorize/3","ref":"Boruta.Oauth.Application.html#c:authorize_success/2","title":"Boruta.Oauth.Application.authorize_success/2","type":"callback"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.introspect/2","ref":"Boruta.Oauth.Application.html#c:introspect_error/2","title":"Boruta.Oauth.Application.introspect_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.introspect/2","ref":"Boruta.Oauth.Application.html#c:introspect_success/2","title":"Boruta.Oauth.Application.introspect_success/2","type":"callback"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.preauthorize/3","ref":"Boruta.Oauth.Application.html#c:preauthorize_error/2","title":"Boruta.Oauth.Application.preauthorize_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.preauthorize/3","ref":"Boruta.Oauth.Application.html#c:preauthorize_success/2","title":"Boruta.Oauth.Application.preauthorize_success/2","type":"callback"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.revoke/2","ref":"Boruta.Oauth.Application.html#c:revoke_error/2","title":"Boruta.Oauth.Application.revoke_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.revoke/2","ref":"Boruta.Oauth.Application.html#c:revoke_success/1","title":"Boruta.Oauth.Application.revoke_success/1","type":"callback"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.token/2","ref":"Boruta.Oauth.Application.html#c:token_error/2","title":"Boruta.Oauth.Application.token_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.token/2","ref":"Boruta.Oauth.Application.html#c:token_success/2","title":"Boruta.Oauth.Application.token_success/2","type":"callback"},{"doc":"Openid requests entrypoint, provides additional artifacts to OAuth as stated in Openid Connect Core 1.0 . Note : this module follows inverted heaxagonal architecture, its functions will invoke callbacks of the given module argument and return its result. The definition of those callbacks are provided by either Boruta.Openid.Application or Boruta.Openid.JwksApplication and Boruta.Openid.UserinfoApplication","ref":"Boruta.Openid.html","title":"Boruta.Openid","type":"module"},{"doc":"","ref":"Boruta.Openid.html#jwks/2","title":"Boruta.Openid.jwks/2","type":"function"},{"doc":"","ref":"Boruta.Openid.html#userinfo/2","title":"Boruta.Openid.userinfo/2","type":"function"},{"doc":"Implement this behaviour in the application layer of your OpenID Connect provider. This behaviour gives all callbacks triggered invoking Boruta.Openid module functions. Note : This behaviour is splitted into Boruta.Openid.JwksApplication and Boruta.Openid.UserinfoApplication providing utilities to implement the different OpenID Connect endpoints independently.","ref":"Boruta.Openid.Application.html","title":"Boruta.Openid.Application","type":"behaviour"},{"doc":"This function will be triggered in case of success invoking Boruta.Openid.jwks/2","ref":"Boruta.Openid.Application.html#c:jwk_list/2","title":"Boruta.Openid.Application.jwk_list/2","type":"callback"},{"doc":"This function will be triggered when request is unauthorized invoking Boruta.Openid.userinfo/2","ref":"Boruta.Openid.Application.html#c:unauthorized/2","title":"Boruta.Openid.Application.unauthorized/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Openid.userinfo/2","ref":"Boruta.Openid.Application.html#c:userinfo_fetched/2","title":"Boruta.Openid.Application.userinfo_fetched/2","type":"callback"},{"doc":"This task will help creation of a basic OAuth/OpenID Connect server by providing needed phoenix controllers, views and templates to expose OAuth endpoints. Controllers are unit tested using Mox, you'll need to add that dependency in order to run them (see below). Examples mix boruta . gen . controllers Post instalation steps You can add OAuth routes in web application router as follow to expose controller actions scope &quot;/oauth&quot; , MyAppWeb.Oauth do pipe_through :api post &quot;/revoke&quot; , RevokeController , :revoke post &quot;/token&quot; , TokenController , :token post &quot;/introspect&quot; , IntrospectController , :introspect end scope &quot;/openid&quot; , MyAppWeb.Openid do pipe_through [ :api ] get &quot;/userinfo&quot; , UserinfoController , :userinfo post &quot;/userinfo&quot; , UserinfoController , :userinfo get &quot;/jwks&quot; , JwksController , :jwks_index end #### scope &quot;/oauth&quot; , MyAppWeb.Oauth do pipe_through [ :browser , :fetch_current_user ] get &quot;/authorize&quot; , AuthorizeController , :authorize end ## OR scope &quot;/openid&quot; , MyAppWeb.Openid do pipe_through [ :browser , :fetch_current_user ] get &quot;/authorize&quot; , AuthorizeController , :authorize end Testing Add mox dependency in order to run controller unit tests { :mox , &quot;~&gt; 0.5&quot; , only : :test } Add following in config/test.exs config :myapp , :oauth_module , Boruta.OauthMock config :myapp , :openid_module , Boruta.OpenidMock Add following in test/test_helper.exs Mox . defmock ( Boruta.OauthMock , for : Boruta.OauthModule ) Mox . defmock ( Boruta.OpenidMock , for : Boruta.OpenidModule ) User flows All flows involving resource owners need its integration guided by Boruta.Oauth.ResourceOwners behaviour. For authorize endpoint, you'll need to assign current_user with a plug and setup login redirections which, with raw setup, raise an error where it is required.","ref":"Mix.Tasks.Boruta.Gen.Controllers.html","title":"Mix.Tasks.Boruta.Gen.Controllers","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Boruta.Gen.Controllers.html#run/1","title":"Mix.Tasks.Boruta.Gen.Controllers.run/1","type":"function"},{"doc":"Migration task for Boruta. Creates oauth_clients , oauth_scopes and oauth_tokens tables. Note : This task will create migration files to keep your integration up to date by checking migration file and module names to create missing ones. Thus it is not recommanded to change naming since it will recreate the migration in further runs. Provided migrations create_boruta creates base tables needed to provide OAuth 2.0 openid_connect Boruta 2.0 refactoring, provide OpenID Connect clients_refresh_tokens client configurations for refresh tokens clients_public_revoke client configuration to revoke tokens without providing client secret store_previous_token store previous token while refreshing access tokens Examples mix boruta . gen . migration","ref":"Mix.Tasks.Boruta.Gen.Migration.html","title":"Mix.Tasks.Boruta.Gen.Migration","type":"task"},{"doc":"OAuth application behaviour - authorize endpoint Implement this behaviour in the application layer of your OAuth provider. The callbacks are triggered while calling functions from Boruta.Oauth module.","ref":"Boruta.Oauth.AuthorizeApplication.html","title":"Boruta.Oauth.AuthorizeApplication","type":"behaviour"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.authorize/3","ref":"Boruta.Oauth.AuthorizeApplication.html#c:authorize_error/2","title":"Boruta.Oauth.AuthorizeApplication.authorize_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.authorize/3","ref":"Boruta.Oauth.AuthorizeApplication.html#c:authorize_success/2","title":"Boruta.Oauth.AuthorizeApplication.authorize_success/2","type":"callback"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.preauthorize/3","ref":"Boruta.Oauth.AuthorizeApplication.html#c:preauthorize_error/2","title":"Boruta.Oauth.AuthorizeApplication.preauthorize_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.preauthorize/3","ref":"Boruta.Oauth.AuthorizeApplication.html#c:preauthorize_success/2","title":"Boruta.Oauth.AuthorizeApplication.preauthorize_success/2","type":"callback"},{"doc":"OAuth application behaviour - introspect endpoint Implement this behaviour in the application layer of your OAuth provider. The callbacks are triggered while calling functions from Boruta.Oauth module.","ref":"Boruta.Oauth.IntrospectApplication.html","title":"Boruta.Oauth.IntrospectApplication","type":"behaviour"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.introspect/2","ref":"Boruta.Oauth.IntrospectApplication.html#c:introspect_error/2","title":"Boruta.Oauth.IntrospectApplication.introspect_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.introspect/2","ref":"Boruta.Oauth.IntrospectApplication.html#c:introspect_success/2","title":"Boruta.Oauth.IntrospectApplication.introspect_success/2","type":"callback"},{"doc":"OAuth application behaviour - revoke endpoint Implement this behaviour in the application layer of your OAuth provider. The callbacks are triggered while calling functions from Boruta.Oauth module.","ref":"Boruta.Oauth.RevokeApplication.html","title":"Boruta.Oauth.RevokeApplication","type":"behaviour"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.revoke/2","ref":"Boruta.Oauth.RevokeApplication.html#c:revoke_error/2","title":"Boruta.Oauth.RevokeApplication.revoke_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.revoke/2","ref":"Boruta.Oauth.RevokeApplication.html#c:revoke_success/1","title":"Boruta.Oauth.RevokeApplication.revoke_success/1","type":"callback"},{"doc":"OAuth application behaviour - token endpoint Implement this behaviour in the application layer of your OAuth provider. The callbacks are triggered while calling functions from Boruta.Oauth module.","ref":"Boruta.Oauth.TokenApplication.html","title":"Boruta.Oauth.TokenApplication","type":"behaviour"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.token/2","ref":"Boruta.Oauth.TokenApplication.html#c:token_error/2","title":"Boruta.Oauth.TokenApplication.token_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.token/2","ref":"Boruta.Oauth.TokenApplication.html#c:token_success/2","title":"Boruta.Oauth.TokenApplication.token_success/2","type":"callback"},{"doc":"Implement this behaviour in the application layer of your OpenID Connect provider. This behaviour gives all callbacks triggered invoking Boruta.Openid.jwks/2 function.","ref":"Boruta.Openid.JwksApplication.html","title":"Boruta.Openid.JwksApplication","type":"behaviour"},{"doc":"This function will be triggered in case of success invoking Boruta.Opeind.jwks/2","ref":"Boruta.Openid.JwksApplication.html#c:jwk_list/2","title":"Boruta.Openid.JwksApplication.jwk_list/2","type":"callback"},{"doc":"Implement this behaviour in the application layer of your OpenID Connect provider. This behaviour gives all callbacks triggered invoking Boruta.Openid.userinfo/2 function.","ref":"Boruta.Openid.UserinfoApplication.html","title":"Boruta.Openid.UserinfoApplication","type":"behaviour"},{"doc":"This function will be triggered when request is unauthorized invoking Boruta.Openid.userinfo/2","ref":"Boruta.Openid.UserinfoApplication.html#c:unauthorized/2","title":"Boruta.Openid.UserinfoApplication.unauthorized/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Openid.userinfo/2","ref":"Boruta.Openid.UserinfoApplication.html#c:userinfo_fetched/2","title":"Boruta.Openid.UserinfoApplication.userinfo_fetched/2","type":"callback"},{"doc":"Response returned in case of authorization request success. Provides utilities and mandatory data needed to respond to the authorize part of implicit, code and hybrid flows.","ref":"Boruta.Oauth.AuthorizeResponse.html","title":"Boruta.Oauth.AuthorizeResponse","type":"module"},{"doc":"","ref":"Boruta.Oauth.AuthorizeResponse.html#from_tokens/2","title":"Boruta.Oauth.AuthorizeResponse.from_tokens/2","type":"function"},{"doc":"","ref":"Boruta.Oauth.AuthorizeResponse.html#redirect_to_url/1","title":"Boruta.Oauth.AuthorizeResponse.redirect_to_url/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.AuthorizeResponse.html#t:t/0","title":"Boruta.Oauth.AuthorizeResponse.t/0","type":"type"},{"doc":"Response returned in case of introspection request success. Provides mandatory data needed to respond to token introspection.","ref":"Boruta.Oauth.IntrospectResponse.html","title":"Boruta.Oauth.IntrospectResponse","type":"module"},{"doc":"","ref":"Boruta.Oauth.IntrospectResponse.html#from_error/1","title":"Boruta.Oauth.IntrospectResponse.from_error/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.IntrospectResponse.html#from_token/1","title":"Boruta.Oauth.IntrospectResponse.from_token/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.IntrospectResponse.html#t:t/0","title":"Boruta.Oauth.IntrospectResponse.t/0","type":"type"},{"doc":"Response returned in case of access token request success. Provides utilities and mandatory data needed to respond to the token part of client credentials, resource owner password, code and hybrid flows.","ref":"Boruta.Oauth.TokenResponse.html","title":"Boruta.Oauth.TokenResponse","type":"module"},{"doc":"","ref":"Boruta.Oauth.TokenResponse.html#from_token/1","title":"Boruta.Oauth.TokenResponse.from_token/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.TokenResponse.html#t:t/0","title":"Boruta.Oauth.TokenResponse.t/0","type":"type"},{"doc":"Boruta.Ecto.Client resource administration","ref":"Boruta.Ecto.Admin.Clients.html","title":"Boruta.Ecto.Admin.Clients","type":"module"},{"doc":"Creates a client. Examples iex&gt; create_client ( %{ field : value } ) { :ok , % Client { } } iex&gt; create_client ( %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"Boruta.Ecto.Admin.Clients.html#create_client/1","title":"Boruta.Ecto.Admin.Clients.create_client/1","type":"function"},{"doc":"Deletes a Client. Examples iex&gt; delete_client ( client ) { :ok , % Client { } } iex&gt; delete_client ( client ) { :error , % Ecto.Changeset { } }","ref":"Boruta.Ecto.Admin.Clients.html#delete_client/1","title":"Boruta.Ecto.Admin.Clients.delete_client/1","type":"function"},{"doc":"Gets a single client. Raises Ecto.NoResultsError if the Client does not exist. Examples iex&gt; get_client! ( 123 ) % Client { } iex&gt; get_client! ( 456 ) ** (Ecto.NoResultsError)","ref":"Boruta.Ecto.Admin.Clients.html#get_client!/1","title":"Boruta.Ecto.Admin.Clients.get_client!/1","type":"function"},{"doc":"Returns the list of clients. Examples iex&gt; list_clients ( ) [ % Client { } , ... ]","ref":"Boruta.Ecto.Admin.Clients.html#list_clients/0","title":"Boruta.Ecto.Admin.Clients.list_clients/0","type":"function"},{"doc":"Regenerates client secret. If a secret is provided as parameter updates it. Examples iex&gt; regenerate_client_secret ( client ) { :ok , % Client { } }","ref":"Boruta.Ecto.Admin.Clients.html#regenerate_client_secret/2","title":"Boruta.Ecto.Admin.Clients.regenerate_client_secret/2","type":"function"},{"doc":"Updates a client. Examples iex&gt; update_client ( client , %{ field : new_value } ) { :ok , % Client { } } iex&gt; update_client ( client , %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"Boruta.Ecto.Admin.Clients.html#update_client/2","title":"Boruta.Ecto.Admin.Clients.update_client/2","type":"function"},{"doc":"Boruta.Ecto.Scope resource administration","ref":"Boruta.Ecto.Admin.Scopes.html","title":"Boruta.Ecto.Admin.Scopes","type":"module"},{"doc":"Creates a scope. Examples iex&gt; create_scope ( %{ field : value } ) { :ok , % Scope { } } iex&gt; create_scope ( %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"Boruta.Ecto.Admin.Scopes.html#create_scope/1","title":"Boruta.Ecto.Admin.Scopes.create_scope/1","type":"function"},{"doc":"Deletes a Scope. Examples iex&gt; delete_scope ( scope ) { :ok , % Scope { } } iex&gt; delete_scope ( scope ) { :error , % Ecto.Changeset { } }","ref":"Boruta.Ecto.Admin.Scopes.html#delete_scope/1","title":"Boruta.Ecto.Admin.Scopes.delete_scope/1","type":"function"},{"doc":"Gets a single scope. Raises Ecto.NoResultsError if the Scope does not exist. Examples iex&gt; get_scope! ( 123 ) % Scope { } iex&gt; get_scope! ( 456 ) ** (Ecto.NoResultsError)","ref":"Boruta.Ecto.Admin.Scopes.html#get_scope!/1","title":"Boruta.Ecto.Admin.Scopes.get_scope!/1","type":"function"},{"doc":"Return scopes corresponding to the given ids. Examples iex&gt; get_scopes_by_ids ( [ &quot;9864decf-8aa4-4387-a7e4-19d1a059c912&quot; , &quot;7b6ec16d-ad8f-4332-ac55-559184ec0f51&quot; ] ) [ % Scope { } , ... ]","ref":"Boruta.Ecto.Admin.Scopes.html#get_scopes_by_ids/1","title":"Boruta.Ecto.Admin.Scopes.get_scopes_by_ids/1","type":"function"},{"doc":"Return scopes corresponding to the given names. Examples iex&gt; get_scopes_by_names ( [ &quot;first:scope&quot; , &quot;second:scope&quot; ] ) [ % Scope { } , ... ]","ref":"Boruta.Ecto.Admin.Scopes.html#get_scopes_by_names/1","title":"Boruta.Ecto.Admin.Scopes.get_scopes_by_names/1","type":"function"},{"doc":"Returns the list of scopes. Examples iex&gt; list_scopes ( ) [ % Scope { } , ... ]","ref":"Boruta.Ecto.Admin.Scopes.html#list_scopes/0","title":"Boruta.Ecto.Admin.Scopes.list_scopes/0","type":"function"},{"doc":"Updates a scope. Examples iex&gt; update_scope ( scope , %{ field : new_value } ) { :ok , % Scope { } } iex&gt; update_scope ( scope , %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"Boruta.Ecto.Admin.Scopes.html#update_scope/2","title":"Boruta.Ecto.Admin.Scopes.update_scope/2","type":"function"},{"doc":"Boruta.Ecto.Token resource administration","ref":"Boruta.Ecto.Admin.Tokens.html","title":"Boruta.Ecto.Admin.Tokens","type":"module"},{"doc":"","ref":"Boruta.Ecto.Admin.Tokens.html#delete_inactive_tokens/1","title":"Boruta.Ecto.Admin.Tokens.delete_inactive_tokens/1","type":"function"},{"doc":"Returns all active tokens given Ecto.Queryable (defaults to all). Examples iex&gt; list_active_tokens ( ) [ % Token { } , ... ]","ref":"Boruta.Ecto.Admin.Tokens.html#list_active_tokens/1","title":"Boruta.Ecto.Admin.Tokens.list_active_tokens/1","type":"function"},{"doc":"OAuth requests authorization","ref":"Boruta.Oauth.Authorization.html","title":"Boruta.Oauth.Authorization","type":"protocol"},{"doc":"Checks if request is valid for token creation for given request, depending of implementation.","ref":"Boruta.Oauth.Authorization.html#preauthorize/1","title":"Boruta.Oauth.Authorization.preauthorize/1","type":"function"},{"doc":"Creates and returns tokens for given request, depending of implementation.","ref":"Boruta.Oauth.Authorization.html#token/1","title":"Boruta.Oauth.Authorization.token/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Authorization.html#t:t/0","title":"Boruta.Oauth.Authorization.t/0","type":"type"},{"doc":"Check against given params and return the corresponding access token","ref":"Boruta.Oauth.Authorization.AccessToken.html","title":"Boruta.Oauth.Authorization.AccessToken","type":"module"},{"doc":"Authorize the access token corresponding to the given params. Examples iex&gt; authorize ( %{ value : &quot;value&quot; } ) { :ok , % Boruta.Oauth.Token { ... } }","ref":"Boruta.Oauth.Authorization.AccessToken.html#authorize/1","title":"Boruta.Oauth.Authorization.AccessToken.authorize/1","type":"function"},{"doc":"Check against given params and return the corresponding client","ref":"Boruta.Oauth.Authorization.Client.html","title":"Boruta.Oauth.Authorization.Client","type":"module"},{"doc":"Authorize the client corresponding to the given params. Examples iex&gt; authorize ( id : &quot;id&quot; , secret : &quot;secret&quot; ) { :ok , % Boruta.Oauth.Client { ... } }","ref":"Boruta.Oauth.Authorization.Client.html#authorize/1","title":"Boruta.Oauth.Authorization.Client.authorize/1","type":"function"},{"doc":"Check against given params and return the corresponding code","ref":"Boruta.Oauth.Authorization.Code.html","title":"Boruta.Oauth.Authorization.Code","type":"module"},{"doc":"Authorize the code corresponding to the given params. Examples iex&gt; authorize ( value : &quot;value&quot; , redirect_uri : &quot;redirect_uri&quot; ) { :ok , % Boruta.Oauth.Token { ... } }","ref":"Boruta.Oauth.Authorization.Code.html#authorize/1","title":"Boruta.Oauth.Authorization.Code.authorize/1","type":"function"},{"doc":"Check OpenID Connect nonce against given request","ref":"Boruta.Oauth.Authorization.Nonce.html","title":"Boruta.Oauth.Authorization.Nonce","type":"protocol"},{"doc":"Authorize the given request corresponding the nonce value. Examples iex&gt; authorize ( % CodeRequest { ... } ) :ok","ref":"Boruta.Oauth.Authorization.Nonce.html#authorize/1","title":"Boruta.Oauth.Authorization.Nonce.authorize/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Authorization.Nonce.html#t:t/0","title":"Boruta.Oauth.Authorization.Nonce.t/0","type":"type"},{"doc":"Check against given params and return the corresponding resource owner","ref":"Boruta.Oauth.Authorization.ResourceOwner.html","title":"Boruta.Oauth.Authorization.ResourceOwner","type":"module"},{"doc":"Authorize the resource owner corresponding to the given params. Examples iex&gt; authorize ( id : &quot;id&quot; ) { :ok , % Boruta.Oauth.ResourceOwner { ... } }","ref":"Boruta.Oauth.Authorization.ResourceOwner.html#authorize/1","title":"Boruta.Oauth.Authorization.ResourceOwner.authorize/1","type":"function"},{"doc":"Check against given params and return the corresponding scopes","ref":"Boruta.Oauth.Authorization.Scope.html","title":"Boruta.Oauth.Authorization.Scope","type":"module"},{"doc":"Authorize the given scope according to the given client. Examples iex&gt; authorize ( %{ scope : &quot;scope&quot; , client : % Client { ... } } ) { :ok , &quot;scope&quot; }","ref":"Boruta.Oauth.Authorization.Scope.html#authorize/1","title":"Boruta.Oauth.Authorization.Scope.authorize/1","type":"function"},{"doc":"Struct encapsulating an authorization success data","ref":"Boruta.Oauth.AuthorizationSuccess.html","title":"Boruta.Oauth.AuthorizationSuccess","type":"module"},{"doc":"","ref":"Boruta.Oauth.AuthorizationSuccess.html#t:t/0","title":"Boruta.Oauth.AuthorizationSuccess.t/0","type":"type"},{"doc":"Access token introspection","ref":"Boruta.Oauth.Introspect.html","title":"Boruta.Oauth.Introspect","type":"module"},{"doc":"Returns corresponding token for the given Boruta.Oauth.IntrospectRequest Note : Invalid tokens returns an error {:error, %Error{error: :invalid_access_token, ...}} . That must be rescued to return %{&quot;active&quot; =&gt; false} in application implementation. Examples iex&gt; token ( % IntrospectRequest { client_id : &quot;client_id&quot; , client_secret : &quot;client_secret&quot; , token : &quot;token&quot; } ) { :ok , % Token { ... } }","ref":"Boruta.Oauth.Introspect.html#token/1","title":"Boruta.Oauth.Introspect.token/1","type":"function"},{"doc":"Access token revocation","ref":"Boruta.Oauth.Revoke.html","title":"Boruta.Oauth.Revoke","type":"module"},{"doc":"Revokes token according to the given Boruta.Oauth.RevokeRequest Examples iex&gt; token ( % RevokeRequest { client_id : &quot;client_id&quot; , client_secret : &quot;client_secret&quot; , token : &quot;token&quot; } ) :ok","ref":"Boruta.Oauth.Revoke.html#token/1","title":"Boruta.Oauth.Revoke.token/1","type":"function"},{"doc":"Access token context","ref":"Boruta.Oauth.AccessTokens.html","title":"Boruta.Oauth.AccessTokens","type":"behaviour"},{"doc":"Persists a token with the given params.","ref":"Boruta.Oauth.AccessTokens.html#c:create/2","title":"Boruta.Oauth.AccessTokens.create/2","type":"callback"},{"doc":"Returns a Boruta.Oauth.Token either by value or refresh_token .","ref":"Boruta.Oauth.AccessTokens.html#c:get_by/1","title":"Boruta.Oauth.AccessTokens.get_by/1","type":"callback"},{"doc":"Revokes the given Boruta.Oauth.Token .","ref":"Boruta.Oauth.AccessTokens.html#c:revoke/1","title":"Boruta.Oauth.AccessTokens.revoke/1","type":"callback"},{"doc":"Client context","ref":"Boruta.Oauth.Clients.html","title":"Boruta.Oauth.Clients","type":"behaviour"},{"doc":"Returns client authorized scopes. The scopes will be granted for every requests to the given client.","ref":"Boruta.Oauth.Clients.html#c:authorized_scopes/1","title":"Boruta.Oauth.Clients.authorized_scopes/1","type":"callback"},{"doc":"Returns a Boruta.Oauth.Client given id.","ref":"Boruta.Oauth.Clients.html#c:get_client/1","title":"Boruta.Oauth.Clients.get_client/1","type":"callback"},{"doc":"Returns all clients jwk public keys","ref":"Boruta.Oauth.Clients.html#c:list_clients_jwk/0","title":"Boruta.Oauth.Clients.list_clients_jwk/0","type":"callback"},{"doc":"Code context","ref":"Boruta.Oauth.Codes.html","title":"Boruta.Oauth.Codes","type":"behaviour"},{"doc":"Persists a token according to given params.","ref":"Boruta.Oauth.Codes.html#c:create/1","title":"Boruta.Oauth.Codes.create/1","type":"callback"},{"doc":"Returns a Boruta.Oauth.Token by value and redirect_uri .","ref":"Boruta.Oauth.Codes.html#c:get_by/1","title":"Boruta.Oauth.Codes.get_by/1","type":"callback"},{"doc":"Revokes the given Boruta.Oauth.Token .","ref":"Boruta.Oauth.Codes.html#c:revoke/1","title":"Boruta.Oauth.Codes.revoke/1","type":"callback"},{"doc":"Resource owner context","ref":"Boruta.Oauth.ResourceOwners.html","title":"Boruta.Oauth.ResourceOwners","type":"behaviour"},{"doc":"Returns a list of authorized scopes for a given resource owner. These scopes will be granted is requested for the user.","ref":"Boruta.Oauth.ResourceOwners.html#c:authorized_scopes/1","title":"Boruta.Oauth.ResourceOwners.authorized_scopes/1","type":"callback"},{"doc":"Determines if given password is correct.","ref":"Boruta.Oauth.ResourceOwners.html#c:check_password/2","title":"Boruta.Oauth.ResourceOwners.check_password/2","type":"callback"},{"doc":"Returns id_token identity claims for the given resource owner","ref":"Boruta.Oauth.ResourceOwners.html#c:claims/2","title":"Boruta.Oauth.ResourceOwners.claims/2","type":"callback"},{"doc":"Returns a resource owner by (username, password) or (id). Returns nil for non matching results.","ref":"Boruta.Oauth.ResourceOwners.html#c:get_by/1","title":"Boruta.Oauth.ResourceOwners.get_by/1","type":"callback"},{"doc":"","ref":"Boruta.Oauth.ResourceOwners.html#t:claims/0","title":"Boruta.Oauth.ResourceOwners.claims/0","type":"type"},{"doc":"Scope context","ref":"Boruta.Oauth.Scopes.html","title":"Boruta.Oauth.Scopes","type":"behaviour"},{"doc":"","ref":"Boruta.Oauth.Scopes.html#c:public/0","title":"Boruta.Oauth.Scopes.public/0","type":"callback"},{"doc":"OAuth client schema and utilities","ref":"Boruta.Oauth.Client.html","title":"Boruta.Oauth.Client","type":"module"},{"doc":"","ref":"Boruta.Oauth.Client.html#check_redirect_uri/2","title":"Boruta.Oauth.Client.check_redirect_uri/2","type":"function"},{"doc":"","ref":"Boruta.Oauth.Client.html#check_secret/2","title":"Boruta.Oauth.Client.check_secret/2","type":"function"},{"doc":"","ref":"Boruta.Oauth.Client.html#grant_type_supported?/2","title":"Boruta.Oauth.Client.grant_type_supported?/2","type":"function"},{"doc":"Returns grant types supported by the server. Boruta.Oauth.Client supported_grant_types attribute may be a subset of them.","ref":"Boruta.Oauth.Client.html#grant_types/0","title":"Boruta.Oauth.Client.grant_types/0","type":"function"},{"doc":"","ref":"Boruta.Oauth.Client.html#public_refresh_token?/1","title":"Boruta.Oauth.Client.public_refresh_token?/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Client.html#public_revoke?/1","title":"Boruta.Oauth.Client.public_revoke?/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Client.html#t:t/0","title":"Boruta.Oauth.Client.t/0","type":"type"},{"doc":"OpenID Connect id token schema and utilities","ref":"Boruta.Oauth.IdToken.html","title":"Boruta.Oauth.IdToken","type":"module"},{"doc":"","ref":"Boruta.Oauth.IdToken.html#generate/2","title":"Boruta.Oauth.IdToken.generate/2","type":"function"},{"doc":"","ref":"Boruta.Oauth.IdToken.html#hash_alg/1","title":"Boruta.Oauth.IdToken.hash_alg/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.IdToken.html#signature_algorithms/0","title":"Boruta.Oauth.IdToken.signature_algorithms/0","type":"function"},{"doc":"","ref":"Boruta.Oauth.IdToken.html#signature_type/1","title":"Boruta.Oauth.IdToken.signature_type/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.IdToken.html#t:tokens/0","title":"Boruta.Oauth.IdToken.tokens/0","type":"type"},{"doc":"Oauth resource owner schema","ref":"Boruta.Oauth.ResourceOwner.html","title":"Boruta.Oauth.ResourceOwner","type":"module"},{"doc":"","ref":"Boruta.Oauth.ResourceOwner.html#t:t/0","title":"Boruta.Oauth.ResourceOwner.t/0","type":"type"},{"doc":"OAuth scope schema and utilities","ref":"Boruta.Oauth.Scope.html","title":"Boruta.Oauth.Scope","type":"module"},{"doc":"Determines if artifact is authorized to access given scope.","ref":"Boruta.Oauth.Scope.html#authorized_scopes/3","title":"Boruta.Oauth.Scope.authorized_scopes/3","type":"function"},{"doc":"Determines if scope string contains openid scope.","ref":"Boruta.Oauth.Scope.html#contains_openid?/1","title":"Boruta.Oauth.Scope.contains_openid?/1","type":"function"},{"doc":"Returns 'openid' scope","ref":"Boruta.Oauth.Scope.html#openid/0","title":"Boruta.Oauth.Scope.openid/0","type":"function"},{"doc":"Splits an OAuth scope string into individual scopes as string Examples iex&gt; scope ( &quot;a:scope another:scope&quot; ) [ &quot;a:scope&quot; , &quot;another:scope&quot; ]","ref":"Boruta.Oauth.Scope.html#split/1","title":"Boruta.Oauth.Scope.split/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Scope.html#t:raw/0","title":"Boruta.Oauth.Scope.raw/0","type":"type"},{"doc":"","ref":"Boruta.Oauth.Scope.html#t:t/0","title":"Boruta.Oauth.Scope.t/0","type":"type"},{"doc":"OAuth access token and code schema and utilities","ref":"Boruta.Oauth.Token.html","title":"Boruta.Oauth.Token","type":"module"},{"doc":"Determines if a token is valid, neither expired nor revoked. Examples iex&gt; ensure_valid ( % Boruta.Oauth.Token { revoked_at : nil } ) :ok iex&gt; ensure_valid ( % Boruta.Oauth.Token { } ) { :error , &quot;Token revoked.&quot; }","ref":"Boruta.Oauth.Token.html#ensure_valid/2","title":"Boruta.Oauth.Token.ensure_valid/2","type":"function"},{"doc":"Determines if a token is expired Examples iex&gt; expired? ( % Boruta.Oauth.Token { expires_at : 1628260754 } ) false iex&gt; expired? ( % Boruta.Oauth.Token { expires_at : 0 } ) # 1st january 1970 true","ref":"Boruta.Oauth.Token.html#expired?/3","title":"Boruta.Oauth.Token.expired?/3","type":"function"},{"doc":"Returns an hexadecimal SHA512 hash of given string Examples iex&gt; hash ( &quot;foo&quot; ) &quot;F7FBBA6E0636F890E56FBBF3283E524C6FA3204AE298382D624741D0DC6638326E282C41BE5E4254D8820772C5518A2C5A8C0C7F7EDA19594A7EB539453E1ED7&quot;","ref":"Boruta.Oauth.Token.html#hash/1","title":"Boruta.Oauth.Token.hash/1","type":"function"},{"doc":"Determines if a token is revoked. Examples iex&gt; revoked? ( % Boruta.Oauth.Token { revoked_at : nil } ) :ok iex&gt; revoked? ( % Boruta.Oauth.Token { } ) false","ref":"Boruta.Oauth.Token.html#revoked?/1","title":"Boruta.Oauth.Token.revoked?/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Token.html#userinfo/1","title":"Boruta.Oauth.Token.userinfo/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Token.html#t:t/0","title":"Boruta.Oauth.Token.t/0","type":"type"},{"doc":"Authorization code request","ref":"Boruta.Oauth.AuthorizationCodeRequest.html","title":"Boruta.Oauth.AuthorizationCodeRequest","type":"module"},{"doc":"Type representing an authorization code request as stated in OAuth 2.0 RFC .","ref":"Boruta.Oauth.AuthorizationCodeRequest.html#t:t/0","title":"Boruta.Oauth.AuthorizationCodeRequest.t/0","type":"type"},{"doc":"Client credentials request","ref":"Boruta.Oauth.ClientCredentialsRequest.html","title":"Boruta.Oauth.ClientCredentialsRequest","type":"module"},{"doc":"Type representing a client credentials request as stated in OAuth 2.0 RFC .","ref":"Boruta.Oauth.ClientCredentialsRequest.html#t:t/0","title":"Boruta.Oauth.ClientCredentialsRequest.t/0","type":"type"},{"doc":"Code request","ref":"Boruta.Oauth.CodeRequest.html","title":"Boruta.Oauth.CodeRequest","type":"module"},{"doc":"","ref":"Boruta.Oauth.CodeRequest.html#require_nonce?/1","title":"Boruta.Oauth.CodeRequest.require_nonce?/1","type":"function"},{"doc":"Type representing a code request as stated in OAuth 2.0 RFC . Note : resource_owner is an addition that must be provided by the application layer.","ref":"Boruta.Oauth.CodeRequest.html#t:t/0","title":"Boruta.Oauth.CodeRequest.t/0","type":"type"},{"doc":"Hybrid request","ref":"Boruta.Oauth.HybridRequest.html","title":"Boruta.Oauth.HybridRequest","type":"module"},{"doc":"Type representing an hybrid request as stated in OpenId Connect core 1.0 . Note : resource_owner is an addition that must be provided by the application layer.","ref":"Boruta.Oauth.HybridRequest.html#t:t/0","title":"Boruta.Oauth.HybridRequest.t/0","type":"type"},{"doc":"Introspect request","ref":"Boruta.Oauth.IntrospectRequest.html","title":"Boruta.Oauth.IntrospectRequest","type":"module"},{"doc":"Type representing an introspect request as stated in Introspect RFC .","ref":"Boruta.Oauth.IntrospectRequest.html#t:t/0","title":"Boruta.Oauth.IntrospectRequest.t/0","type":"type"},{"doc":"Resource owner password credentials request","ref":"Boruta.Oauth.PasswordRequest.html","title":"Boruta.Oauth.PasswordRequest","type":"module"},{"doc":"Type representing a resource owner password credentials request as stated in OAuth 2.0 RFC .","ref":"Boruta.Oauth.PasswordRequest.html#t:t/0","title":"Boruta.Oauth.PasswordRequest.t/0","type":"type"},{"doc":"Refresh token request","ref":"Boruta.Oauth.RefreshTokenRequest.html","title":"Boruta.Oauth.RefreshTokenRequest","type":"module"},{"doc":"Type representing a refresh token request as stated in OAuth 2.0 RFC .","ref":"Boruta.Oauth.RefreshTokenRequest.html#t:t/0","title":"Boruta.Oauth.RefreshTokenRequest.t/0","type":"type"},{"doc":"Build an oauth request struct from given input. Note : Input must have the shape or be a %Plug.Conn{} request.","ref":"Boruta.Oauth.Request.html","title":"Boruta.Oauth.Request","type":"module"},{"doc":"Create request struct from an OAuth authorize request. Note : resource owner must be provided as current_user assigns. Examples iex&gt; authorize_request ( %{ query_params : %{ &quot;response_type&quot; =&gt; &quot;token&quot; , &quot;client_id&quot; =&gt; &quot;client_id&quot; , &quot;redirect_uri&quot; =&gt; &quot;redirect_uri&quot; } , } , % User { ... } ) { :ok , % TokenRequest { ... } }","ref":"Boruta.Oauth.Request.html#authorize_request/2","title":"Boruta.Oauth.Request.authorize_request/2","type":"function"},{"doc":"Create request struct from an OAuth introspect request. Examples iex&gt; introspect_request ( %{ body_params : %{ &quot;token&quot; =&gt; &quot;token&quot; , &quot;client_id&quot; =&gt; &quot;client_id&quot; , &quot;client_secret&quot; =&gt; &quot;client_secret&quot; , } } ) { :ok , % IntrospectRequest { ... } }","ref":"Boruta.Oauth.Request.html#introspect_request/1","title":"Boruta.Oauth.Request.introspect_request/1","type":"function"},{"doc":"Create request struct from an OAuth revoke request. Examples iex&gt; revoke_request ( %{ body_params : %{ &quot;token&quot; =&gt; &quot;token&quot; , &quot;client_id&quot; =&gt; &quot;client_id&quot; , &quot;client_secret&quot; =&gt; &quot;client_secret&quot; , } } ) { :ok , % RevokeRequest { ... } }","ref":"Boruta.Oauth.Request.html#revoke_request/1","title":"Boruta.Oauth.Request.revoke_request/1","type":"function"},{"doc":"Create request struct from an OAuth token request. Examples iex&gt; token_request ( %{ body_params : %{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot; , &quot;client_id&quot; =&gt; &quot;client_id&quot; , &quot;client_secret&quot; =&gt; &quot;client_secret&quot; } } ) { :ok , % ClientCredentialsRequest { ... } }","ref":"Boruta.Oauth.Request.html#token_request/1","title":"Boruta.Oauth.Request.token_request/1","type":"function"},{"doc":"Revoke request","ref":"Boruta.Oauth.RevokeRequest.html","title":"Boruta.Oauth.RevokeRequest","type":"module"},{"doc":"Type representing an revoke request as stated in OAuth 2.0 Token revocation RFC .","ref":"Boruta.Oauth.RevokeRequest.html#t:t/0","title":"Boruta.Oauth.RevokeRequest.t/0","type":"type"},{"doc":"Implicit request","ref":"Boruta.Oauth.TokenRequest.html","title":"Boruta.Oauth.TokenRequest","type":"module"},{"doc":"","ref":"Boruta.Oauth.TokenRequest.html#require_nonce?/1","title":"Boruta.Oauth.TokenRequest.require_nonce?/1","type":"function"},{"doc":"Type representing an implicit request as stated in OAuth 2.0 RFC and OpenId Connect core 1.0 Note : resource_owner is an addition that must be provided by the application layer.","ref":"Boruta.Oauth.TokenRequest.html#t:t/0","title":"Boruta.Oauth.TokenRequest.t/0","type":"type"},{"doc":"Encapsulate injected Boruta.Oauth.AccessTokens adapter in context configuration","ref":"Boruta.AccessTokensAdapter.html","title":"Boruta.AccessTokensAdapter","type":"module"},{"doc":"Callback implementation for Boruta.Oauth.AccessTokens.create/2 .","ref":"Boruta.AccessTokensAdapter.html#create/2","title":"Boruta.AccessTokensAdapter.create/2","type":"function"},{"doc":"Callback implementation for Boruta.Oauth.AccessTokens.get_by/1 .","ref":"Boruta.AccessTokensAdapter.html#get_by/1","title":"Boruta.AccessTokensAdapter.get_by/1","type":"function"},{"doc":"Callback implementation for Boruta.Oauth.AccessTokens.revoke/1 .","ref":"Boruta.AccessTokensAdapter.html#revoke/1","title":"Boruta.AccessTokensAdapter.revoke/1","type":"function"},{"doc":"Boruta Ecto adapter uses Nebulex in order to cache entities","ref":"Boruta.Cache.html","title":"Boruta.Cache","type":"module"},{"doc":"A convenience function for getting the primary storage cache.","ref":"Boruta.Cache.html#__primary__/0","title":"Boruta.Cache.__primary__/0","type":"function"},{"doc":"A convenience function for joining the cache to the cluster.","ref":"Boruta.Cache.html#join_cluster/0","title":"Boruta.Cache.join_cluster/0","type":"function"},{"doc":"A convenience function for removing the cache from the cluster.","ref":"Boruta.Cache.html#leave_cluster/0","title":"Boruta.Cache.leave_cluster/0","type":"function"},{"doc":"A convenience function for getting the cluster nodes.","ref":"Boruta.Cache.html#nodes/0","title":"Boruta.Cache.nodes/0","type":"function"},{"doc":"This is the cache for the primary storage.","ref":"Boruta.Cache.Primary.html","title":"Boruta.Cache.Primary","type":"module"},{"doc":"A convenience function for retrieving the current generations.","ref":"Boruta.Cache.Primary.html#generations/0","title":"Boruta.Cache.Primary.generations/0","type":"function"},{"doc":"A convenience function for creating new generations.","ref":"Boruta.Cache.Primary.html#new_generation/1","title":"Boruta.Cache.Primary.new_generation/1","type":"function"},{"doc":"A convenience function for retrieving the newer generation.","ref":"Boruta.Cache.Primary.html#newer_generation/0","title":"Boruta.Cache.Primary.newer_generation/0","type":"function"},{"doc":"A convenience function for reset the GC timer.","ref":"Boruta.Cache.Primary.html#reset_generation_timer/0","title":"Boruta.Cache.Primary.reset_generation_timer/0","type":"function"},{"doc":"Encapsulate injected Boruta.Oauth.Clients adapter in context configuration","ref":"Boruta.ClientsAdapter.html","title":"Boruta.ClientsAdapter","type":"module"},{"doc":"Callback implementation for Boruta.Oauth.Clients.authorized_scopes/1 .","ref":"Boruta.ClientsAdapter.html#authorized_scopes/1","title":"Boruta.ClientsAdapter.authorized_scopes/1","type":"function"},{"doc":"Callback implementation for Boruta.Oauth.Clients.get_client/1 .","ref":"Boruta.ClientsAdapter.html#get_client/1","title":"Boruta.ClientsAdapter.get_client/1","type":"function"},{"doc":"Callback implementation for Boruta.Oauth.Clients.list_clients_jwk/0 .","ref":"Boruta.ClientsAdapter.html#list_clients_jwk/0","title":"Boruta.ClientsAdapter.list_clients_jwk/0","type":"function"},{"doc":"Encapsulate injected Boruta.Oauth.Codes adapter in context configuration","ref":"Boruta.CodesAdapter.html","title":"Boruta.CodesAdapter","type":"module"},{"doc":"Callback implementation for Boruta.Oauth.Codes.create/1 .","ref":"Boruta.CodesAdapter.html#create/1","title":"Boruta.CodesAdapter.create/1","type":"function"},{"doc":"Callback implementation for Boruta.Oauth.Codes.get_by/1 .","ref":"Boruta.CodesAdapter.html#get_by/1","title":"Boruta.CodesAdapter.get_by/1","type":"function"},{"doc":"Callback implementation for Boruta.Oauth.Codes.revoke/1 .","ref":"Boruta.CodesAdapter.html#revoke/1","title":"Boruta.CodesAdapter.revoke/1","type":"function"},{"doc":"Encapsulate injected Boruta.Oauth.Scopes adapter in context configuration","ref":"Boruta.ScopesAdapter.html","title":"Boruta.ScopesAdapter","type":"module"},{"doc":"Callback implementation for Boruta.Oauth.Scopes.public/0 .","ref":"Boruta.ScopesAdapter.html#public/0","title":"Boruta.ScopesAdapter.public/0","type":"function"},{"doc":"Ecto Adapter Client Schema","ref":"Boruta.Ecto.Client.html","title":"Boruta.Ecto.Client","type":"module"},{"doc":"","ref":"Boruta.Ecto.Client.html#create_changeset/2","title":"Boruta.Ecto.Client.create_changeset/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Client.html#secret_changeset/2","title":"Boruta.Ecto.Client.secret_changeset/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Client.html#update_changeset/2","title":"Boruta.Ecto.Client.update_changeset/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Client.html#t:t/0","title":"Boruta.Ecto.Client.t/0","type":"type"},{"doc":"Ecto Adapter Scope Schema","ref":"Boruta.Ecto.Scope.html","title":"Boruta.Ecto.Scope","type":"module"},{"doc":"","ref":"Boruta.Ecto.Scope.html#assoc_changeset/2","title":"Boruta.Ecto.Scope.assoc_changeset/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Scope.html#changeset/2","title":"Boruta.Ecto.Scope.changeset/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Scope.html#t:t/0","title":"Boruta.Ecto.Scope.t/0","type":"type"},{"doc":"Ecto Adapter Token Schema","ref":"Boruta.Ecto.Token.html","title":"Boruta.Ecto.Token","type":"module"},{"doc":"","ref":"Boruta.Ecto.Token.html#changeset/2","title":"Boruta.Ecto.Token.changeset/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Token.html#changeset_with_refresh_token/2","title":"Boruta.Ecto.Token.changeset_with_refresh_token/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Token.html#code_changeset/2","title":"Boruta.Ecto.Token.code_changeset/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Token.html#t:t/0","title":"Boruta.Ecto.Token.t/0","type":"type"},{"doc":"HTTP BasicAuth utilities Provide utilities to decode Basic authorization header as stated in RFC 7617 - The 'Basic' HTTP Authentication Scheme","ref":"Boruta.BasicAuth.html","title":"Boruta.BasicAuth","type":"module"},{"doc":"Decode given authorization header and returns an array containing username and password. Examples iex&gt; Boruta.BasicAuth . decode ( &quot;Basic dXNlcm5hbWU6cGFzc3dvcmQ=&quot; ) { :ok , [ &quot;username&quot; , &quot;password&quot; ] } iex&gt; Boruta.BasicAuth . decode ( &quot;bad_authorization_header&quot; ) { :error , &quot;`bad_authorization_header` is not a valid Basic authorization header.&quot; }","ref":"Boruta.BasicAuth.html#decode/1","title":"Boruta.BasicAuth.decode/1","type":"function"},{"doc":"OAuth bearer token utilities Provide utilities to manipulate bearer tokens as stated in RFC 6750 - Bearer token usage","ref":"Boruta.Oauth.BearerToken.html","title":"Boruta.Oauth.BearerToken","type":"module"},{"doc":"","ref":"Boruta.Oauth.BearerToken.html#extract_token/1","title":"Boruta.Oauth.BearerToken.extract_token/1","type":"function"},{"doc":"Behaviour to implement utilities to generate token value. This must be implemented in the module configured as token_generator set in config.exs","ref":"Boruta.Oauth.TokenGenerator.html","title":"Boruta.Oauth.TokenGenerator","type":"behaviour"},{"doc":"Generates a token value from token entity.","ref":"Boruta.Oauth.TokenGenerator.html#c:generate/2","title":"Boruta.Oauth.TokenGenerator.generate/2","type":"callback"},{"doc":"Generates a secret from client entity.","ref":"Boruta.Oauth.TokenGenerator.html#c:secret/1","title":"Boruta.Oauth.TokenGenerator.secret/1","type":"callback"},{"doc":"Utility to validate the request according to the given parameters","ref":"Boruta.Oauth.Validator.html","title":"Boruta.Oauth.Validator","type":"module"},{"doc":"Validates given OAuth parameters. Examples iex&gt; validate ( :token , %{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot; , &quot;client_id&quot; =&gt; &quot;client_id&quot; , &quot;client_secret&quot; =&gt; &quot;client_secret&quot; } ) { :ok , %{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot; , &quot;client_id&quot; =&gt; &quot;client_id&quot; , &quot;client_secret&quot; =&gt; &quot;client_secret&quot; } } iex&gt; validate ( :authorize , %{ } ) { :error , &quot;Request is not a valid OAuth request. Need a response_type param.&quot; }","ref":"Boruta.Oauth.Validator.html#validate/2","title":"Boruta.Oauth.Validator.validate/2","type":"function"},{"doc":"Boruta OAuth errors Note : Intended to follow OAuth 2.0 errors . Additionnal errors are provided as purpose.","ref":"Boruta.Oauth.Error.html","title":"Boruta.Oauth.Error","type":"module"},{"doc":"Returns the URL to be redirected according to error format.","ref":"Boruta.Oauth.Error.html#redirect_to_url/1","title":"Boruta.Oauth.Error.redirect_to_url/1","type":"function"},{"doc":"Returns the OAuth error augmented with the format according to request type.","ref":"Boruta.Oauth.Error.html#with_format/2","title":"Boruta.Oauth.Error.with_format/2","type":"function"},{"doc":"","ref":"Boruta.Oauth.Error.html#t:t/0","title":"Boruta.Oauth.Error.t/0","type":"type"},{"doc":"Boruta OAuth/OpenID Connect provider core Boruta is the core of an OAuth 2.0 and OpenID Connect provider implementing according business rules. This library also provides a generator to create phoenix controllers, views and templates to have a basic provider up and running. It is intended to follow RFCs: RFC 6749 - The OAuth 2.0 Authorization Framework RFC 7662 - OAuth 2.0 Token Introspection RFC 7009 - OAuth 2.0 Token Revocation RFC 7636 - Proof Key for Code Exchange by OAuth Public Clients And specification from OpenID Connect: OpenID Connect core 1.0 This package is meant to help to provide authorization into Elixir applications. With it, you can perform part or all of authorization code, implicit, hybrid, client credentials, or resource owner password credentials grants flows. It also helps introspecting and revoking tokens.","ref":"readme.html","title":"README","type":"extras"},{"doc":"Master branch documentation can be found here Stable documentation is hosted on hexdocs.pm","ref":"readme.html#documentation","title":"README - Documentation","type":"extras"},{"doc":"An example of integration can be found here , it followed the integration steps described in below guides section.","ref":"readme.html#integration-example","title":"README - Integration example","type":"extras"},{"doc":"This package has succesfully passed basic, implicit and hybrid OpenID Profiles certifications as of May 7th, 2022 for its version 2.1.2 . This certification was performed with the above sample server.","ref":"readme.html#openid-certification","title":"README - OpenID Certification","type":"extras"},{"doc":"Here are some guides helping the integration of OAuth/OpenID Connect in your systems: Basic OAuth/OpenID Connect provider integration How to create an OAuth client Client request authorization Notes about pkce","ref":"readme.html#guides","title":"README - Guides","type":"extras"},{"doc":"It is a work in progress, all feedbacks / feature requests / improvements are welcome","ref":"readme.html#feedback","title":"README - Feedback","type":"extras"},{"doc":"Boruta provides as its core all authorization business rules in order to handle the underlying authorization logic of OAuth and OpenID Connect. Then it provides a generator that helps to create required controllers, views, and templates as we will see.","ref":"provider_integration.html","title":"Setting up Boruta OAuth/OpenID Connect provider","type":"extras"},{"doc":"We will start by botsrapping a Phoenix web application with authentication capabilities provided by phx.gen.auth since OAuth and OpenID Connect specifications do not provide any recommendations about how to authenticate users. Instead, it provides all protocols required to authorize them to secure an HTTP service, with relative identity information in destination to the client brought by OpenID Connect core. Here we go, first bootstrapping the application: ~&gt; mix phx.new boruta_example Then the authentication ~&gt; mix phx.gen.auth Accounts User users We have now a web application in which we can log in. If you want to know more about those, have a look at phx.new and phx.gen.auth documentations. In order to run the newly created application, you have to set up dependencies and the database. You'll find the development database configuration in config/dev.exs file, fill it with valid PostgreSQL credentials, you would be able to run ~&gt; mix do deps.get, ecto.setup Here is the application up and running, starting the webserver with mix phx.server you'll be able to visit http://localhost:4000 with your favorite browser.","ref":"provider_integration.html#1-bootstrap-the-application","title":"Setting up Boruta OAuth/OpenID Connect provider - 1. Bootstrap the application","type":"extras"},{"doc":"Once the application is up, we can go on to the authorization part. First, you can add the Boruta dependency in mix.exs # mix.exs def deps do ... { :boruta , &quot;~&gt; 2.0&quot; } ... end After that, you'll be able to generate controllers in order to expose Oauth and OpenID Connect core specifications endpoints and database migrations to persist required clients, scopes, and tokens needed by your newly created provider. ~&gt; mix do deps.get, boruta.gen.migration, ecto.migrate, boruta.gen.controllers It will print the remaining steps to have the provider up and running as described in the documentation . From there we will skip the testing part which uses Mox in order to mock Boruta and focus tests on the application layer.","ref":"provider_integration.html#2-bootstrap-boruta","title":"Setting up Boruta OAuth/OpenID Connect provider - 2. Bootstrap Boruta","type":"extras"},{"doc":"As described in boruta.gen.controllers mix task output, you need to expose controller actions in router.ex as follow # lib/boruta_example_web/router.ex scope &quot;/oauth&quot; , BorutaExampleWeb.Oauth do pipe_through :api post &quot;/revoke&quot; , RevokeController , :revoke post &quot;/token&quot; , TokenController , :token post &quot;/introspect&quot; , IntrospectController , :introspect end scope &quot;/oauth&quot; , BorutaExampleWeb.Oauth do pipe_through [ :browser , :fetch_current_user ] get &quot;/authorize&quot; , AuthorizeController , :authorize end scope &quot;/openid&quot; , BorutaExampleWeb.Openid do pipe_through [ :browser , :fetch_current_user ] get &quot;/authorize&quot; , AuthorizeController , :authorize end And give mandatory boruta configuration # config/config.exs config :boruta , Boruta.Oauth , repo : BorutaExample.Repo , issuer : &quot;https://example.com&quot; Here client credentials flow should be up. For user flows you need further configuration and implement Boruta.Oauth.ResourceOwners context.","ref":"provider_integration.html#3-configure-boruta","title":"Setting up Boruta OAuth/OpenID Connect provider - 3. Configure Boruta","type":"extras"},{"doc":"In order to have user flows operational, you need to implement Boruta.Oauth.ResourceOwners context as described in Boruta README . Here it would look like # lib/boruta_example/resource_owners.ex defmodule BorutaExample.ResourceOwners do @behaviour Boruta.Oauth.ResourceOwners alias Boruta.Oauth.ResourceOwner alias MyApp.Accounts.User alias MyApp.Repo @impl Boruta.Oauth.ResourceOwners def get_by ( username : username ) do with % User { id : id , email : email , last_login_at : last_login_at } &lt;- Repo . get_by ( User , email : username ) do { :ok , % ResourceOwner { sub : to_string ( id ) , username : email , last_login_at : last_login_at } } else _ -&gt; { :error , &quot;User not found.&quot; } end end def get_by ( sub : sub ) do with % User { id : id , email : email , last_login_at : last_login_at } &lt;- Repo . get_by ( User , id : sub ) do { :ok , % ResourceOwner { sub : to_string ( id ) , username : email , last_login_at : last_login_at } } else _ -&gt; { :error , &quot;User not found.&quot; } end end @impl Boruta.Oauth.ResourceOwners def check_password ( resource_owner , password ) do user = Repo . get_by ( User , id : resource_owner . sub ) case User . valid_password? ( user , password ) do true -&gt; :ok false -&gt; { :error , &quot;Invalid email or password.&quot; } end end @impl Boruta.Oauth.ResourceOwners def authorized_scopes ( % ResourceOwner { } ) , do : [ ] @impl Boruta.Oauth.ResourceOwners def claims ( _resource_owner , _scope ) , do : %{ } end and inject it with the main configuration # config/config.exs config :boruta , Boruta.Oauth , repo : BorutaExample.Repo , contexts : [ resource_owners : BorutaExample.ResourceOwners ] Last, you'll have to setup is the redirection in the OAuth authorize controller # lib/boruta_example_web/controllers/oauth/authorize_controller.ex ... defp redirect_to_login ( conn ) do redirect ( conn , to : Routes . user_session_path ( conn , :new ) ) end Here all OAuth flows should be up and running!","ref":"provider_integration.html#4-user-flows","title":"Setting up Boruta OAuth/OpenID Connect provider - 4. User flows","type":"extras"},{"doc":"In order to setup OpenID Connect flows, you need to tweak phx.gen.auth in order to redirect to login after logging out # lib/boruta_example_web/controllers/user_auth.ex:80 ... def log_out_user ( conn ) do ... conn |&gt; renew_session ( ) |&gt; delete_resp_cookie ( @remember_me_cookie ) |&gt; redirect ( to : Routes . user_session_path ( conn , :new ) ) end And set redirections in the OpenID authorize controller # lib/boruta_example_web/controllers/openid/authorize_controller.ex ... defp redirect_to_login ( conn ) do redirect ( conn , to : Routes . user_session_path ( conn , :new ) ) end defp log_out_user ( conn ) do UserAuth . log_out_user ( conn ) end Last, you need to store the last_login_at field of users to keep track of the timestamp when users log in # priv/repo/migrations/&lt;timestamp&gt;_add_last_login_at_to_users.exs defmodule BorutaExample.Repo.Migrations.AddLastLoginAtToUsers do use Ecto.Migration def change do alter table ( :users ) do add :last_login_at , :utc_datetime_usec end end end # lib/boruta_example/accounts.ex:223 ... def update_last_login_at ( user ) do user |&gt; User . login_changeset ( ) |&gt; Repo . update! ( ) end ... def log_in_user ( conn , user , params \\\\ %{ } ) do token = Accounts . generate_user_session_token ( user ) Accounts . update_last_login_at ( user ) ... # lib/boruta_example/accounts/user.ex ... schema &quot;users&quot; do ... field :last_login_at , :utc_datetime_usec timestamps ( ) end ... def login_changeset ( user ) do change ( user , last_login_at : DateTime . utc_now ( ) ) end Here we are! You have a basic OpenID Connect provider. You can now create a client as described here and start using it. Departing from there, you can use any OAuth/OpenID Connect client of your choice. Hope you enjoyed the way so far. The process can definitely be improved at some points, all contributions of any kind will be very welcome.","ref":"provider_integration.html#5-openid-connect","title":"Setting up Boruta OAuth/OpenID Connect provider - 5. OpenID Connect","type":"extras"},{"doc":"Boruta goes with some administration utilities . The best way to have an OAuth client up and running is to create a client with a seed script as following example: # priv/repo/seeds.exs id = SecureRandom . uuid ( ) secret = SecureRandom . hex ( 64 ) Boruta.Ecto.Admin . create_client ( %{ id : id , # OAuth client_id secret : secret , # OAuth client_secret name : &quot;A client&quot; , # Display name access_token_ttl : 60 * 60 * 24 , # one day authorization_code_ttl : 60 , # one minute refresh_token_ttl : 60 * 60 * 24 * 30 , # one month id_token_ttl : 60 * 60 * 24 , # one day id_token_signature_alg : &quot;RS256&quot; , # ID token signature algorithm, defaults to &quot;RS512&quot; redirect_uris : [ &quot;http://redirect.uri&quot; ] , # OAuth client redirect_uris authorize_scope : true , # take following authorized_scopes into account (skip public scopes) authorized_scopes : [ %{ name : &quot;a:scope&quot; } ] , # scopes that are authorized using this client supported_grant_types : [ # client supported grant types &quot;client_credentials&quot; , &quot;password&quot; , &quot;authorization_code&quot; , &quot;refresh_token&quot; , &quot;implicit&quot; , &quot;revoke&quot; , &quot;introspect&quot; ] , pkce : false , # PKCE enabled public_refresh_token : false , # do not require client_secret for refreshing tokens public_revoke : false # do not require client_secret for revoking tokens } ) |&gt; IO . inspect Or so, you can use all administration utilities described in Boruta API documentation to manage all entities you need to have your server up and running. If some are missing or can be improved do not hesitate to open an issue on GitLab , it would be very welcome.","ref":"create_client.html","title":"How to create an OAuth client","type":"extras"},{"doc":"Once your authorization server setup done, you can deliver tokens that help limiting access to HTTP services . In order to do so, you can check validity and security information of access tokens provided in requests. Here we will see how restrict access using a bearer token as described in RFC .","ref":"authorize_requests.html","title":"Client request authorization","type":"extras"},{"doc":"In a monolith, you have access to Boruta API (documented here ) and can directly use it in order to restrict access to endpoints. Creating a Plug and add it to the request pipeline would be the prefered way to perform authorization. Here is an example of basic plugs. def MyAppWeb.Plugs.Authorization do import Plug use MyAppWeb , :controller alias Boruta.Oauth.Authorization alias Boruta.Oauth.Scope def require_authenticated ( conn , _opts ) do with [ authorization_header ] &lt;- get_req_header ( conn , &quot;authorization&quot; ) , [ _authorization_header , bearer ] &lt;- Regex . run ( ~r/Bearer (.+)/ , authorization_header ) , { :ok , token } &lt;- Authorization.AccessToken . authorize ( value : bearer ) do conn |&gt; assign ( :current_token , token ) |&gt; assign ( :current_user , Accounts . get_user! ( token . sub ) ) else _ -&gt; conn |&gt; put_status ( :unauthorized ) |&gt; put_view ( MyAppWeb.ErrorView ) |&gt; render ( &quot;401.json&quot; ) |&gt; halt ( ) end end def authorize ( conn , [ _h | _t ] = required_scopes ) do current_scopes = Scope . split ( conn . assigns [ :current_token ] . scope ) case Enum . empty? ( required_scopes -- current_scopes ) do true -&gt; conn false -&gt; conn |&gt; put_status ( :forbidden ) |&gt; put_view ( MyAppWeb.ErrorView ) |&gt; render ( &quot;403.json&quot; ) |&gt; halt ( ) end end end Then you can invoke those plugs in your router and controllers: # lib/my_app_web/router.ex ... import MyAppWeb.Plugs.Authorization , only : [ require_authenticated : 2 ] pipeline :protected_api do plug ( :accepts , [ &quot;json&quot; ] ) plug ( :require_authenticated ) end ... # in controllers ... import MyAppWeb.Plugs.Authorization , only : [ authorize : 2 ] plug ( :authorize , [ &quot;resource:read&quot; ] ) when action in [ :index , :show ] plug ( :authorize , [ &quot;resource:write&quot; ] ) when action in [ :create , :update , :delete ] ...","ref":"authorize_requests.html#in-a-monolithic-application","title":"Client request authorization - In a monolithic application","type":"extras"},{"doc":"With an authorization server set up, an introspect endpoint is exposed to check token validity and provide security information as described in RFC . You can create your own plugs as above but instead of using Boruta API, request the authorization server to get an introspected token and all information needed to perform authorization. Note: the grant type introspect must be active on the client you are performing the requests with. Example of introspect response: { &quot;active&quot;: true, &quot;client_id&quot;: &quot;6a2f41a3-c54c-fce8-32d2-0324e1c32e20&quot;, &quot;exp&quot;: 1639752235, &quot;iat&quot;: 1639748635, &quot;iss&quot;: &quot;https://oauth.boruta.patatoid.fr&quot;, &quot;scope&quot;: &quot;resource:read resource:write&quot;, &quot;sub&quot;: &quot;b69c4bb6-a47b-4254-9d87-cf42bb223262&quot;, &quot;username&quot;: &quot;test@test.test&quot; }","ref":"authorize_requests.html#in-a-microservice-environment","title":"Client request authorization - In a microservice environment","type":"extras"},{"doc":"","ref":"pkce.html","title":"Notes for pkce extension","type":"extras"},{"doc":"There are a few pre-requisites. Have a way to inject :current_user in the conn, otherwise implement it before continuing, also keep in mind that in most cases the :current_user is the same as the resource owner on OAuth. On our server, we need to create a client with pkce value as true. alias Boruta.Ecto.Admin.Clients { :ok , client } = %{ authorization_code_ttl : 60 , access_token_ttl : 60 * 60 , pkce : true , name : &quot;My Awesome Client App&quot; , redirect_uris : [ &quot;http://localhost:4000&quot; ] } |&gt; Clients . create_client ( ) We will get the client.id among others fields.","ref":"pkce.html#prerequisites","title":"Notes for pkce extension - Prerequisites","type":"extras"},{"doc":"From the client perspective, who is in charge of sending the code_challenge and code_challenge_method among other fields during the request of the code, there is a code_verifier variable which is a key concept to keep in mind because code_challenge depends on it and also depends on code_challenge_method , let's see an example. In our client, we must have an URL to request the /oauth/authorize endpoint to get the code. To build the URL we should follow a similar approach to the proposed. client_id = client . id code_verifier = &quot;a-strong-random-string&quot; state = &quot;a-random-verifiable-state-on-client&quot; # When the code challenge method is S256, we must follow the standard code_challenge = BASE64URL-ENCODE(SHA256(ASCII(code_verifier))) code_challenge_method = &quot;S256&quot; code_challenge = :crypto . hash ( :sha256 , code_verifier ) |&gt; Base . url_encode64 ( padding : false ) # Only if our client does not support sha256 crypto it goes through the plain method. Then code_challenge = code_verifier # # Keep in mind that it must be used only if your architecture does not support Sha256 crypto. otherwise use it. # # code_challenge_method = &quot;plain&quot; # code_challenge = code_verifier # Then we are ready to build your URL. url = &quot;http://localhost:4000/oauth/authorize?response_type=code&amp;client_id= \#{ client_id } &amp;redirect_uri=http://localhost:4000&amp;state= \#{ state } &amp;code_challenge= \#{ code_challenge } &amp;code_challenge_method= \#{ code_challenge_method } &quot; &quot;http://localhost:4000/oauth/authorize?response_type=code&amp;client_id=client-id&amp;redirect_uri=http://localhost:4000&amp;state=a-random-verifiable-state-on-client&amp;code_challenge=PdSbV6nNRlruDAqmULREHO_pLwfmNnNGA-HGIjmc6VA==&amp;code_challenge_method=S256&quot; You can paste the URL in your browser with a logged user and retrieve the code from the response URL. Having the code the next step is to retrieve a token, in this case, the client must call the oauth/token to get it. Based on the previous step, a request example could look like this. curl --location --request POST &#39;http://localhost:4000/oauth/token&#39; \\ --header &#39;Content-Type: application/x-www-form-urlencoded&#39; \\ --data-urlencode &#39;grant_type=authorization_code&#39; \\ --data-urlencode &#39;client_id=c96951c5c-f7b5-4d03-ac09-657833d113df&#39; \\ --data-urlencode &#39;code=4vlPc010GKutGlCYeT3VZFbyoVewmtNPOo0c5DXvt1iQ9pBd0BkeCutVwHWFNq8vzdTfIPppFGlhuYuOIWtvnU&#39; \\ --data-urlencode &#39;code_verifier=a-strong-random-string&#39; \\ --data-urlencode &#39;redirect_uri=http://localhost:4000&#39; \\ --data-urlencode &#39;state=a-random-verifiable-state-on-client&#39; It's important to notice that the code_verifier has the value previously generated and is not encrypted. This is because the server knows that you use encrypted method S256, and it implements the logic to handle it. And that is all. If your configuration is right, you will get a response like this. {&quot;access_token&quot;:&quot;BHYQabRwti673RVhoMnqXtrvgiEilawgaAj1KosrQV9pGQ4DBENXzhUHeSjZE4K02S8bNtlNL2gU9bzFhKMoQK&quot;,&quot;expires_in&quot;:3600,&quot;refresh_token&quot;:&quot;r90e4S9uaqH59xMO809Ws2uzWPtcaMlcF1J7fcaaSruE1AAc30WuykNAL73GGNECtmYezQSf2CzJGgQWPqdM5M&quot;,&quot;token_type&quot;:&quot;bearer&quot;}","ref":"pkce.html#flow-steps","title":"Notes for pkce extension - Flow steps","type":"extras"},{"doc":"Version 2 of Boruta brings OpenID Connect, several changes were made in order to stick to the specification:","ref":"migration.html","title":"Migration from 1.X","type":"extras"},{"doc":"Boruta.Oauth.AuthorizeResponse and Boruta.Oauth.TokenResponse do not provide token value in value field but prefer giving value by token type code , access_token or id_token . % AuthorizeResponse { type : &quot;code&quot; , value : value , expires_in : 60 } becomes % AuthorizeResponse { type : :code , code : value , expires_in : 60 }","ref":"migration.html#oauth-response-structs-changes","title":"Migration from 1.X - OAuth response structs changes","type":"extras"},{"doc":"boruta.gen.migration task has been updated. Running the task will create required migrations to upgrade database schemas according to the updated Ecto.Schema modules. In order to have the schema up to date, you need to generate migrations and run them mix boruta . gen . migration mix ecto . migrate","ref":"migration.html#database-migrations","title":"Migration from 1.X - Database migrations","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Note that you must run the boruta.gen.migration task to keep your database schema up to date while upgrading to this version. Added handle response_mode in hybrid requests client id_token validation for ecto adapter per client id token signature algorithm configuration (introduce a database schema change) Changed prefer invalid_grant to invalid_code and invalid_refresh_token error messages have been improved","ref":"changelog.html#2-1-4-2022-06-07","title":"Changelog - [2.1.4] - 2022-06-07","type":"extras"},{"doc":"Added handle response_mode in hybrid requests errors Fixed respond to authorize requests with token_type only when an access token is returned generated migrations can be rollbacked clients pkey constraint do not crash on admin create","ref":"changelog.html#2-1-3-2022-05-17","title":"Changelog - [2.1.3] - 2022-05-17","type":"extras"},{"doc":"Fixed hybrid requests shall return all errors as fragment","ref":"changelog.html#2-1-2-2022-05-02","title":"Changelog - [2.1.2] - 2022-05-02","type":"extras"},{"doc":"Fixed dialyzer warning on Boruta.Oauth.Error struct type","ref":"changelog.html#2-1-1-2022-04-30","title":"Changelog - [2.1.1] - 2022-04-30","type":"extras"},{"doc":"Added OpenID Connect jwks endpoint domain and application layer generation OpenID Connect userinfo endpoint domain and application layer generation Fixed OpenID Connect prompt=none login_required errors in domain","ref":"changelog.html#2-1-0-2022-04-29","title":"Changelog - [2.1.0] - 2022-04-29","type":"extras"},{"doc":"Added expose Boruta.Oauth.Client.grant_types/0 expose Boruta.Oauth.IdToken.signature_alg/0 and Boruta.Oauth.IdToken.hash_alg/0 Changed Admin.delete_inactive_tokens/0,1 does not return deleted tokens Fixed generated openid authorize controller prompt=none error params type","ref":"changelog.html#2-0-1-2022-04-12","title":"Changelog - [2.0.1] - 2022-04-12","type":"extras"},{"doc":"Added Boruta.Ecto.Admin.get_scopes_by_names/1 Boruta.Ecto.Admin.regenerate_client_secret/1,2 Boruta.Ecto.Admin.delete_inactive_tokens/0,1 Boruta.Ecto.Client.grant_types/0 ability to insert/update clients with given id/secret inserting/updating a client inserts non existing authorized_scopes oauth_module injection in boruta.gen.controllers generated controllers defalut to Boruta.Oauth Changed store previous token while refreshing access tokens (need to run boruta.gen.migration mix task to be up to date) Boruta.Ecto.Admin.list_active_tokens/0,1 returns query result instead of an Ecto.Query Boruta.Oauth.ResourceOwners.claims/2 callback takes a Boruta.Oauth.ResourceOwner struct instead of sub as parameter","ref":"changelog.html#2-0-0-2022-01-26","title":"Changelog - [2.0.0] - 2022-01-26","type":"extras"},{"doc":"Fixed better Ecto errors management remove padding from pkce code challenge checks reduce resource_owners adapter calls Added domain wildcard for client redirect_uris Removed Ecto ClientsAdapter.get_by(id: id, secret: secret) is removed in preference of ClientsAdapter.get_client(id) and Oauth.Client.check_secret(client, secret) . Ecto ClientsAdapter.get_by(id: id, redirect_uri: redirect_uri) is removed in preference of ClientsAdapter.get_client(id) and Oauth.Client.check_redirect_uri(client, redirect_uri) .","ref":"changelog.html#2-0-0-rc-1-2021-11-17","title":"Changelog - [2.0.0-rc.1] - 2021-11-17","type":"extras"},{"doc":"Added OpenID Connect core 1.0 integration hybrid flow authorization code and implicit grants with OpenID Connect compatibility public_revoke per client configuration allowing to revoke tokens without providing client secret. introspect and revoke supported grant types per client configuration. Changed Boruta.Oauth.AuthorizeResponse and Boruta.Oauth.TokenResponse do not provide token value in value field but prefer giving value by token type code , access_token or id_token . % AuthorizeResponse { type : &quot;code&quot; , value : value , expires_in : 60 } becomes % AuthorizeResponse { type : :code , code : value , expires_in : 60 } add nonce column to tokens default column values migrations migration management boruta.gen.migrations does incremental changes Security codes are revoked after first usage Fixed boruta.gen.controllers generated paths in umbrella apps","ref":"changelog.html#2-0-0-rc-0-2021-10-12","title":"Changelog - [2.0.0-rc.0] 2021-10-12","type":"extras"},{"doc":"Security remove redirect_uris regex pattern check","ref":"changelog.html#1-2-1-2021-10-10","title":"Changelog - [1.2.1] - 2021-10-10","type":"extras"},{"doc":"Added public_refresh_token per client configuration allowing to refresh tokens without providing client secret. refresh_token_ttl per client configuration setting refresh tokens duration (along with refresh_tokne_max_ttl :boruta mix configuration). issuer :boruta mix configuration. Fixed boruta.gen.controllers generated paths in umbrella apps. Refreshed tokens has associated access_token scope as default. Requests with no client secret won't raise an error. Changed invalid_client do not return neither format, nor redirect_uri in Boruta.Oauth.Error .","ref":"changelog.html#1-2-0-2021-09-15","title":"Changelog - [1.2.0] - 2021-09-15","type":"extras"},{"doc":"Added AuthorizeApplication , IntrospectApplication , RevokeApplication , and TokenApplication behaviours allowing to implement separatly different OAuth use cases. list_active_tokens Ecto admin function Boruta.AccessTokensAdapter , Boruta.CodesAdapter , Boruta.ClientsAdapter , and Boruta.ScopesAdapter encapsulating adapters that are set in configuration. Boruta.Oauth.AuthorizeResponse.redirect_to_url/1 function Boruta.Oauth.Error.redirect_to_url/1 function boruta.gen.controllers mix task Boruta.Ecto schemas documentation Security do not issue access_tokens from other clients refresh tokens Fixed Internal server errors when no client_id provided to token and refresh_token grants","ref":"changelog.html#1-1-0-2021-08-16","title":"Changelog - [1.1.0] - 2021-08-16","type":"extras"},{"doc":"Security Refresh token revocation","ref":"changelog.html#1-0-3-2021-07-29","title":"Changelog - [1.0.3] - 2021-07-29","type":"extras"},{"doc":"Added Differents OAuth flows integration guides","ref":"changelog.html#1-0-2-2021-06-29","title":"Changelog - [1.0.2] - 2021-06-29","type":"extras"},{"doc":"Fixed Migration fix generated by mix boruta.gen.migration task Added Documentation","ref":"changelog.html#1-0-1-2021-03-10","title":"Changelog - [1.0.1] - 2021-03-10","type":"extras"},{"doc":"","ref":"changelog.html#1-0-0-2021-03-10","title":"Changelog - [1.0.0] - 2021-03-10","type":"extras"}]